#include <QCoreApplication>

#include <assert.h>
#include <iostream>
#include <stdio.h>

#include "pkcs11.h"
#include "cryptotoken.h"

#define FAILURE 0
#define SUCCESS 1

extern CK_FUNCTION_LIST_PTR fl;


char *EstEID_bin2hex(const char *bin, const int binLength) {
    char *hex = (char *)malloc(binLength * 2 + 1);
    for (unsigned int j = 0; j < binLength; j++) sprintf(hex + (j * 2), "%02X", (unsigned char)bin[j]);
    hex[binLength * 2] = '\0';
    return hex;
}

char *EstEID_hex2bin(const char *hex) {
    //LOG_LOCATION;
    int binLength = strlen(hex) / 2;printf("binLength: %d\n", binLength);
    char *bin = (char *)malloc(binLength);
    char *c = bin;
    char *h = (char *)hex;
    int i = 0;
    while (*h) {
        int x;
        sscanf(h, "%2X", &x);
        *c = x;
        c++;
        h += 2;
        i++;
    }
    return bin;
}


int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    qDebug("hola mundo");

    CryptoToken* ct = new CryptoToken();

    //qDebug(qPrintable(ct->getInfoCryptoki()));

    char strPin[16];
    QString PIN("123456");
    strcpy(strPin,qPrintable(PIN));

    CK_SESSION_HANDLE hSession = CK_INVALID_HANDLE;
    CK_SLOT_ID slotID;
    //CK_SLOT_ID slotID2;

    // inicializacion del criptoki
    CK_RV rv;
    if (!ct->initializeCriptoki())
    {
        //qDebug("fallo la incializacion de criptoki");
        return 1;
    }

    hSession = ct->openSession(strPin, slotID);
    if (hSession == CK_INVALID_HANDLE)
    {
        qDebug("Fallo ptr_SC->openSession");
        rv = C_Finalize(NULL_PTR);
        qDebug("C_Finalize: rv = %x",rv);
        assert(rv == CKR_OK);
        return 1;
    }

    // obtencion de la clave privada para firmar los datos
    CK_OBJECT_HANDLE privateKey = CK_INVALID_HANDLE;

    QString label = "New Key aaraujo";
    privateKey = ct->getPrivateKey(hSession, slotID, label);


    if (privateKey == CK_INVALID_HANDLE)
    {
        qDebug("Fallo ptr_SC->getPrivateKey");
        rv = C_CloseSession(hSession);
        qDebug("C_CloseSession: rv = %x",rv);
        assert(rv == CKR_OK);
        rv = C_Finalize(NULL_PTR);
        qDebug("C_Finalize: rv = %x",rv);
        assert(rv == CKR_OK);
        return 1;
    }


    CK_ULONG slen  = 512;
    CK_BYTE_PTR sign = new CK_BYTE[slen];

    CK_BYTE hash[64/*100*/];
    CK_ULONG hashLen = (CK_ULONG) sizeof(hash);

    // un has recibido del servidor 64 bytes
    // aaf363de5f571c7ae7976ca52891af440d2934a146860c82f0f5672ddc4ee078

    QString hashInHex("aaf363de5f571c7ae7976ca52891af440d2934a146860c82f0f5672ddc4ee078");
    qDebug("longitud de hashInHex: %d", hashInHex.size());


    memcpy(hash,qPrintable(hashInHex), hashInHex.size());
    //hash = (unsigned char) EstEID_hex2bin(qPrintable(hashInHex));


    if(!ct->signSomeData(hSession, privateKey, hash, hashLen, sign, &slen))
    {
        //QMessageBox::warning(this,XCA_TITLE, tr("Process sign for random data failed!"));
        qDebug("Fallo sc_ptr->signSomeData");
        rv = C_CloseSession(hSession);
        qDebug("C_CloseSession: rv = %x",rv);
        assert(rv == CKR_OK);
        rv = C_Finalize(NULL_PTR);
        qDebug("C_Finalize: rv = %x",rv);
        assert(rv == CKR_OK);
        return 1;
    }
    // aqui debo colocar terminar el arreglo de firma con NULL
    sign[slen] = '\0';

    qDebug("Valor de la firma signature:");
    qDebug((const char *) sign);
    qDebug("Valor de signatureLength: ");
    qDebug(qPrintable(QString::number(slen)));

    char * signatureInHex = EstEID_bin2hex((const char *) sign, slen);


    qDebug("valor de la firma en hexadecimal: %s", signatureInHex);

    qDebug("closeSession...");

    ct->closeSession(hSession);


    //return a.exec();
    return 0;
}

