/***************************************************************************
                          smartCard.cpp  -  description
                             -------------------
    begin                : vie sep 24 2004
    copyright            : (C) 2004 by Antonio Araujo, 
                                       Victor Bravo
                                       Jorge Redondo
  
    email                : antonioaraujo@funmrd.gov.ve
                           victorb@funmrd.gov.ve
			   redondo@funmrd.gov.ve
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
 
#ifndef SMARTCARDFUNC_H
#define SMARTCARDFUNC_H
 
 
#define CK_PTR *
#define CK_DEFINE_FUNCTION(returnType, name) \
returnType name
#define CK_DECLARE_FUNCTION(returnType, name) \
returnType name
#define CK_DECLARE_FUNCTION_POINTER(returnType, name) \
returnType (* name)
#define CK_CALLBACK_FUNCTION(returnType, name) \
returnType (* name)
#ifndef NULL_PTR
#define NULL_PTR 0
#endif


#include <openssl/evp.h>
#include <openssl/rsa.h>
#include <openssl/pem.h>
#include <openssl/err.h>

#include <openssl/asn1.h>
#include <openssl/objects.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>
#include <openssl/pkcs12.h>

  
#include "pkcs11.h" 
 

 
 
// declaracion de la estructura biginteger_t utilizada para la conversion de los atributos
// modulo y exponente publico a un objeto EVP_PKEY
typedef struct biginteger {
	CK_BYTE *big_value;
	CK_ULONG big_value_len;
} biginteger_t;

//static 
int cvt_bigint2bn(biginteger_t *from, BIGNUM **to);

// funcion para copiar una plantilla de atributos a un biginteger_t
void copy_attr_to_bigint(CK_ATTRIBUTE_PTR attr, biginteger_t *big);


#endif // SMARTCARDFUNC_H

